Description

=begin

Environment: ruby 2.0.0p195 (2013-05-14) [x64-mingw32] (RubyInstaller with DevKit) on Windows 7 64bit

According to the Process.spawn documentation, the syntax 'cmdname, arg1, ...' doesn't involve the shell. Indeed, on Unix this is true:

((%Process.spawn 'echo', '$PATH'%)) prints '$PATH'.

But on Windows the behaviour is different: executing ((%Process.spawn 'echo', '%Path%'%)) prints the contents of the Path

environment variable.

I think the behaviour should be the same on the different OSes; at least, if it is not possible, the documentation should point it out.

=end

Associated revisions

Revision 0bd6f36aa73059022fd5dd9cc2462cb4b785ba25 - 08/05/2013 04:42 PM - zzak (zzak _)

process.c: [DOC] Document caveats of command form of Process.spawn

with regard to the shell and OS. Patched by Steve Klabnik [Bug #8550]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42391 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0bd6f36a - 08/05/2013 04:42 PM - zzak (zzak _)

process.c: [DOC] Document caveats of command form of Process.spawn

with regard to the shell and OS. Patched by Steve Klabnik [Bug #8550]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42391 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/20/2013 10:48 PM - luislavena (Luis Lavena)

Hello,

On Windows, 'echo' is not an external command, is part of cmd.exe internal commands, like cd and others.

#2 - 06/22/2013 10:11 AM - nobu (Nobuyoshi Nakada)

- Category set to doc

This is a spec.

Otherwise you have to write system(ENV["COMSPEC"], "/c", "echo foo"), and it seems too messy.

Patches for the rdoc are welcome.

#3 - 08/06/2013 12:14 AM - steveklabnik (Steve Klabnik)

- File 0001-Add-caveats-to-Process-spawn-regarding-shell-built-i.patch added

I've attached a patch for the RDOC, what do you think?

#4 - 08/06/2013 01:42 AM - zzak (zzak _)

- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r42391.

Maurizio, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

process.c: [DOC] Document caveats of command form of Process.spawn

with regard to the shell and OS. Patched by Steve Klabnik [Bug #8550]

Files

0001-Add-caveats-to-Process-spawn-regarding-shell-built-i.patch 1.8 KB 08/06/2013 steveklabnik (Steve Klabnik)
